//+------------------------------------------------------------------+
//|                                               EagleSignal_v1.mq4 |
//|                           Copyright  2007, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"
//---- indicator settings
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Aqua
#property indicator_color4 Orange
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 1
#property indicator_width4 1
//---- indicator parameters
extern int     FastMA         =       9;    // Length of fast MA 
extern int     SlowMA         =     100;    // Length of slow MA
extern int     MA_Mode        =       0;    // MA Mode 
extern int     MA_Price       =       0;    // Applied price 
extern int     RVI_Length     =      14;    // RVI Length (Period)
extern double  RVI_BuyLevel   =       0;    // Buy Level  (positive value) 
extern double  RVI_SellLevel  =       0;    // Sell Level (negative value) 
extern int     RVI_Mode       =       0;    // RVI Mode: 0-main,1-signal  
extern int     CCI_Length     =      14;    // CCI Length (Period)
extern double  CCI_BuyLevel   =     100;    // Buy Level  (positive value) 
extern double  CCI_SellLevel  =    -100;    // Sell Level (negative value) 
extern int     CCI_Price      =       5;    // Applied Price 
extern int     AlertMode      =       0;    // Alert Mode: 0-off,1-on

//---- indicator buffers
double UpSignal[];
double DnSignal[]; 
double UpExit[];
double DnExit[]; 
double trend[];


bool   UpTrendAlert=false, DownTrendAlert=false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   string short_name;
//---- drawing settings
   IndicatorBuffers(5);
      
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,108);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,108);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexStyle(3,DRAW_ARROW);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- indicator short name
   IndicatorShortName("EagleSignal");
   SetIndexLabel(0,"UpSignal");
   SetIndexLabel(1,"DnSignal");
   SetIndexDrawBegin(0,SlowMA+FastMA);
   SetIndexDrawBegin(1,SlowMA+FastMA);
//---- indicator buffers mapping
   SetIndexBuffer(0,UpSignal);
   SetIndexBuffer(1,DnSignal);
   SetIndexBuffer(2,UpExit);
   SetIndexBuffer(3,DnExit);
   SetIndexBuffer(4,trend);
   
//---- initialization done
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int limit;
   if(Bars<=SlowMA+FastMA) return(0);
   int CountedBars=IndicatorCounted();
//---- check for possible errors
   if (CountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (CountedBars>0) CountedBars--;
   limit=Bars-CountedBars;
//---- 
   for(int i=limit; i>=0; i--)
   { 
   double fMA = iMA(Symbol(),0,FastMA,0,MA_Mode,MA_Price,i);
   double sMA = iMA(Symbol(),0,SlowMA,0,MA_Mode,MA_Price,i);
        
   double RVI = iRVI(Symbol(),0,RVI_Length,RVI_Mode,i);
   double CCI = iCCI(Symbol(),0,CCI_Length,CCI_Price,i);   
   double CCI1 = iCCI(Symbol(),0,CCI_Length,CCI_Price,i+1); 
   
   trend[i]=trend[i+1]; 
   if (fMA > sMA && RVI > RVI_BuyLevel ) trend[i]= 1; 
   if (fMA < sMA && RVI < RVI_SellLevel) trend[i]=-1; 
      
      if(trend[i]>0)
	   {
	   if (trend[i+1]<0) UpSignal[i] = Low[i]-0.5*iATR(NULL,0,10,i);
	   else UpSignal[i] = EMPTY_VALUE;
	   if (CCI < CCI_SellLevel && CCI1 > CCI_SellLevel ) UpExit[i]=High[i]+0.5*iATR(NULL,0,10,i);  
	   else UpExit[i] = EMPTY_VALUE;
	   DnSignal[i]=EMPTY_VALUE; 
	   DnExit[i]=EMPTY_VALUE;
	   }
	   else
	   if(trend[i]<0)
	   {
	   if (trend[i+1]>0) DnSignal[i] = High[i]+0.5*iATR(NULL,0,10,i);
	   else DnSignal[i] = EMPTY_VALUE;
	   if (CCI > CCI_BuyLevel && CCI1 < CCI_BuyLevel ) DnExit[i]=Low[i]-0.5*iATR(NULL,0,10,i);
	   else DnExit[i] = EMPTY_VALUE;
	   UpSignal[i]=EMPTY_VALUE; 
	   UpExit[i]=EMPTY_VALUE;
	   }
   	         
//----------   
      if (i==0 && AlertMode > 0)
      {
         if (trend[i+1] > 0 && Volume[0]>1)
         {
            if (trend[i+2]<0 && !UpTrendAlert)
	         {
	         string Message = " "+Symbol()+" M"+Period()+": Signal for BUY";
	         Alert (Message); 
	         UpTrendAlert=true; DownTrendAlert=false;
	         } 
	      }
	      else
	      if (trend[i+1] < 0 && Volume[0]>1)
	      {
            if ( trend[i+2]>0 && !DownTrendAlert)
	         {
	         Message = " "+Symbol()+" M"+Period()+": Signal for SELL";
	         Alert (Message); 
	         DownTrendAlert=true; UpTrendAlert=false;     
	         }
	      } 	  
      }	
	} 	         

//---- done
   return(0);
}
//+------------------------------------------------------------------+